import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.math.BigDecimal;

/**
 * Created with IntelliJ IDEA.
 * User: sbaehni
 * Date: 4/25/12
 * Time: 12:27 AM
 * To change this template use File | Settings | File Templates.
 */
public class ComputerTabDocumentParser extends DomDocumentParser {


        public Object[][] parseDocument(Document document) {

            NodeList listOfComputers = document.getElementsByTagName("r");
            int totalComputers = listOfComputers.getLength();
            Object[][] results = new Object[listOfComputers.getLength()][5];

            for(int s=0; s<listOfComputers.getLength() ; s++){

                Node computerNode = listOfComputers.item(s);
                if(computerNode.getNodeType() == Node.ELEMENT_NODE){

                    Object[] row = new Object[5];

                    Element computer = (Element)computerNode;

                    //-------
                    NodeList computerNameList = computer.getElementsByTagName("c0");
                    Element computerName = (Element)computerNameList.item(0);

                    try {
                        row[0] = ((Node)computerName.getChildNodes().item(0)).getNodeValue().trim();
                    }
                    catch (NullPointerException npe) {
                        row[0] = "-";
                    }
                    //-------
                    NodeList firstSeenList = computer.getElementsByTagName("c1");
                    Element firstSeen = (Element)firstSeenList.item(0);

                    try {
                        row[1] = ((Node)firstSeen.getChildNodes().item(0)).getNodeValue().trim();
                    }
                    catch (NullPointerException npe) {
                        row[1] = "-";
                    }
                    //-------
                    NodeList lastSeenList = computer.getElementsByTagName("c2");
                    Element lastSeen = (Element)lastSeenList.item(0);

                    try {
                        row[2] = ((Node)lastSeen.getChildNodes().item(0)).getNodeValue().trim();
                    }
                    catch (NullPointerException npe) {
                        row[2] = "-";
                    }
                    //-------
                    NodeList incomingTrafficList = computer.getElementsByTagName("c3");
                    Element incomingTraffic = (Element)incomingTrafficList.item(0);

                    try {
                        row[3] = this.round(((Node) incomingTraffic.getChildNodes().item(0)).getNodeValue().trim());
                    }
                    catch (NullPointerException npe) {
                        row[3] = new BigDecimal(0);
                    }
                    //-------
                    NodeList outgoingTrafficList = computer.getElementsByTagName("c4");
                    Element outgoingTraffic = (Element)outgoingTrafficList.item(0);

                    try {
                        row[4] = this.round(((Node) outgoingTraffic.getChildNodes().item(0)).getNodeValue().trim());
                    }
                    catch (NullPointerException npe) {
                        row[4] = new BigDecimal(0);
                    }

                    results[s] = row;
                }



            }//end of for loop with s var

            return results;
        }
}
