import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.math.BigDecimal;

/**
 * Created with IntelliJ IDEA.
 * User: sbaehni
 * Date: 4/25/12
 * Time: 12:52 AM
 * To change this template use File | Settings | File Templates.
 */
public class UserTabDocumentParser extends DomDocumentParser {

    public Object[][] parseDocument(Document document) {

        NodeList listOfUsers = document.getElementsByTagName("r");
        Object[][] results = new Object[listOfUsers.getLength()][7];

        for(int s=0; s<listOfUsers.getLength() ; s++){

            Node userNode = listOfUsers.item(s);
            if(userNode.getNodeType() == Node.ELEMENT_NODE){

                Object[] row = new Object[7];

                Element user = (Element)userNode;

                //-------
                NodeList userNameList= user.getElementsByTagName("c0");
                Element userName = (Element)userNameList.item(0);

                try {
                    row[0] = ((Node)userName.getChildNodes().item(0)).getNodeValue().trim();
                }
                catch (NullPointerException npe) {
                    row[0] = "-";
                }

                //-------
                NodeList firstSeenList = user.getElementsByTagName("c1");
                Element firstSeen = (Element)firstSeenList.item(0);

                try {
                    row[1] = ((Node)firstSeen.getChildNodes().item(0)).getNodeValue().trim();
                }
                catch (NullPointerException npe) {
                    row[1] = "-";
                }

                //-------
                NodeList lastSeenList = user.getElementsByTagName("c2");
                Element lastSeen = (Element)lastSeenList.item(0);

                try {
                    row[2] = ((Node)lastSeen.getChildNodes().item(0)).getNodeValue().trim();
                }
                catch (NullPointerException npe) {
                    row[2] = "-";
                }

                //-------
                NodeList incomingTrafficList = user.getElementsByTagName("c3");
                Element incomingTraffic = (Element)incomingTrafficList.item(0);

                try {
                    row[3] = this.round(((Node) incomingTraffic.getChildNodes().item(0)).getNodeValue().trim());
                }
                catch (NullPointerException npe) {
                    row[3] = new BigDecimal(0);
                }

                //-------
                NodeList outgoingTrafficList = user.getElementsByTagName("c4");
                Element outgoingTraffic = (Element)outgoingTrafficList.item(0);

                try {
                    row[4] = this.round(((Node) outgoingTraffic.getChildNodes().item(0)).getNodeValue().trim());
                }
                catch (NullPointerException npe) {
                    row[4] = new BigDecimal(0);
                }

                //-------
                NodeList nbOfSourcesList = user.getElementsByTagName("c5");
                Element nbOfSources = (Element)nbOfSourcesList.item(0);

                try {
                    row[5] = Integer.valueOf(((Node) nbOfSources.getChildNodes().item(0)).getNodeValue().trim());
                }
                catch (NullPointerException npe) {
                    row[5] = Integer.valueOf(0);
                }

                //-------
                NodeList nbOfApplicationsList = user.getElementsByTagName("c6");
                Element nbOfApplications = (Element)nbOfApplicationsList.item(0);

                try {
                    row[6] = Integer.valueOf(((Node) nbOfApplications.getChildNodes().item(0)).getNodeValue().trim());
                }
                catch (NullPointerException npe) {
                    row[6] = Integer.valueOf(0);
                }
                results[s] = row;

            }


        }//end of for loop with s var

        return results;
    }

}
