import org.w3c.dom.Document;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.InputStream;

/**
 * Created with IntelliJ IDEA.
 * User: sbaehni
 * Date: 4/24/12
 * Time: 5:28 PM
 * To change this template use File | Settings | File Templates.
 */
public class WebAPIDemo {
    private JTextField textField1;
    private JPanel mainPanel;
    private JScrollPane myScrollPane;
    private JTabbedPane tabbedPane1;
    private JTable generalTable;
    private JTable userTable;
    private JTabbedPane tabbedPane2;
    private static JFrame frame;

    private final String COMPUTER_INVESTIGATION_URL = "https://192.168.0.222:1671/1/investigations/6975148940/Computers%20Information";

            //"https://192.168.0.84:1671/1/investigations/6975148940/Computers%20Information";
    public final String USERNAME_INVESTIGATION_URL =  "https://192.168.0.222:1671/1/investigations/6756113571/User%20Information?";

   //"https://192.168.0.84:1671/1/investigations/6756113571/User%20Information?";

    public static void main(String[] args) {
        frame = new JFrame("Web API Integration Demo");
        BufferedImage image = null;
        try {
            image = ImageIO.read(frame.getClass().getResource("/images/logo.png"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        frame.setIconImage(image);
        frame.setContentPane(new WebAPIDemo().mainPanel);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        frame.pack();
        frame.setVisible(true);

    }

    public WebAPIDemo() {
        textField1.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent actionEvent) {
                String username = textField1.getText();
                textField1.setText("");
                try {
                    updateUsernameTab(username);
                } catch (Exception e) {
                    e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
                    createErrorDialog(USERNAME_INVESTIGATION_URL);

                }

            }
        });

    }

    public void createErrorDialog(String investigation) {
        JOptionPane.showMessageDialog(frame,
                "Unable to find the published investigation: "+investigation+" in the engine.");
    }

    private void updateComputerTab() throws Exception {
        SSLTrustedConnection connection = new SSLTrustedConnection();
        InputStream urlStream = null;
        try {
         urlStream = connection.createTrustedConnection(COMPUTER_INVESTIGATION_URL);
        }
        catch (Exception e) {
             this.createErrorDialog(COMPUTER_INVESTIGATION_URL);
        }

        Object[][] computerData = new Object[1][5];
        if (urlStream != null) {
        ComputerTabDocumentParser documentParser = new ComputerTabDocumentParser();
        Document document = documentParser.getDocument(urlStream);

            computerData = documentParser.parseDocument(document);
        }
        generalTable = new JTable(computerData, ComputerTableModel.COLUMN_NAMES);
        generalTable.setModel(new ComputerTableModel(computerData));
        generalTable.setFillsViewportHeight(true);

    }


    private void updateUsernameTab(String username) throws Exception {
        SSLTrustedConnection connection = new SSLTrustedConnection();
        InputStream urlStream = connection.createTrustedConnection(USERNAME_INVESTIGATION_URL+username);
        UserTabDocumentParser documentParser = new UserTabDocumentParser();
        Document document = documentParser.getDocument(urlStream);

        Object[][] usernameData = documentParser.parseDocument(document);

        UserTableModel tableModel = new UserTableModel(usernameData);

        userTable.setModel(tableModel);
        userTable.updateUI();

    }



    private void createUIComponents() {
        Object[][] data = new Object[0][7];
        userTable = new JTable(data, UserTableModel.COLUMN_NAMES);
        userTable.setFillsViewportHeight(true);


        try {
            this.updateComputerTab();
        } catch (Exception e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

    }

}
